/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _DX_HWBM_H_INCLUDED
#define _DX_HWBM_H_INCLUDED

namespace Sith
{
	namespace Win32
	{
		enum HBMFormat
		{
			HBMF_R5G6B5,
			HBMF_A1R5G5B5,
			HBMF_R8G8B8,
			HBMF_A8R8G8B8,
			HBMF_X8R8G8B8,

			HBMF_BADFORMAT=0
		};

		class HBMGeometry
		{
		public:
			unsigned int xdim;
			unsigned int ydim;

			HBMFormat bitdepth;

			bool Pow2;

			void* bitdata;

			HBMGeometry()
			{
				bitdata = 0;
				Pow2 = true;
				return;
			};

			HBMGeometry(unsigned int x, unsigned int y, HBMFormat bpp, bool pow2)
			{
				xdim = x;
				ydim = y;
				bitdepth = bpp;
				Pow2 = pow2;
				bitdata = 0;
				return;
			};
		};

		class Hardware_Bitmap
		{
		private:
			unsigned int x_res;
			unsigned int y_res;
			HBMFormat bitdepth;
			bool Pow2;

			bool Locked;

		public:
			IDirect3DTexture9 *TextureData;

			Hardware_Bitmap()
			{
				Locked = false;
				TextureData = 0;
				return;
			};

			~Hardware_Bitmap()
			{
				if(TextureData)
				{
					TextureData->Release();
				};

				return;
			};

			inline HBMGeometry GetGeometry()
			{
				return HBMGeometry(x_res, y_res, bitdepth, Pow2);
			};

			SITHERROR Create(HBMGeometry* GeoData);
			SITHERROR Lock(HBMGeometry* GeoDataBuffer);
			SITHERROR Unlock();
		};
	};
};			

#endif // _DX_HWBM_H_INCLUDED