/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"
#include "fpsproc.h"

#include "ogl_render.h"

double Sith::FPSProc::Framerate = 0;

Sith::FPSProc::FPSProc() : Task("Framerate Counter")
{
	Sith::COG::CogLib::InjectLibraryFunction("fps", 0, &fps);
	return;
};

Sith::SITHERROR Sith::FPSProc::Startup()
{
	// Create framerate display window:
	Display = &UI::UIMain::Get().GetRootWindow().CreateChild();

	Display->SetPosition(50, 10);
	Display->SetSize(0, 0);
	Display->SetRectState(UI::UIRS_TOPRIGHT);

	Display->SetFont("med1.sft");
	Display->SetText("dflt");

	return SE_OK;
};

Sith::SITHERROR Sith::FPSProc::Process()
{
	Framerate = 1 / theTimer.Query();

	char Buffer[5];
	Buffer[4] = '\0';

	_snprintf(Buffer, 4, "%f", Framerate);

	if(Sith::COG::CogLib::GetSetting("ui::drawfps").GetBool() == true)
	{
		Display->Show();
		Display->SetText(std::string(Buffer));
	}
	else
	{
		Display->Hide();
	};

	return SE_OK;
};