/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _OGL_RENDER_COMPILED_H_INCLUDED_
#define _OGL_RENDER_COMPILED_H_INCLUDED_

namespace Sith
{
	namespace Win32
	{
		struct CompiledVertex
		{
			float pos[3];
			float tangent[3];
			float binormal[3];
			float normal[3];
			float tex[2];
			unsigned char color[4];
			int pad;
		};

		class CompiledLevel
		{
		public:
			CompiledVertex *vertex;
			int vertices;
			unsigned int drawbuffer;

			int *surfaceoffset;

			int *drawsize;
			unsigned int **drawindex;
			int *p;
			int drawbins;

			CompiledLevel()
			{
				vertex = 0;
				vertices = 0;
				drawbuffer = 0;
				surfaceoffset = 0;

				drawsize = 0;
				drawindex = 0;
				p = 0;
			}
			~CompiledLevel()
			{
				Clear();
			}
			void Clear();
		private:
		};
	}
}

#endif // _OGL_RENDER_COMPILED_H_INCLUDED_