/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

double Sith::Profiler::TotalAccumulator = 0.0;

Sith::Profiler::Profiler(std::string Name)
{
	TimerAccumulator = 0.0;
	if(Sith::COG::CogLib::GetSetting("log::profile").GetString().length() > 0)
	{
        FILE* temp = fopen(Sith::COG::CogLib::GetSetting("log::profile").GetString().c_str(), "w");
		if(temp) fclose(temp);
	};
	ProfilerName = Name;
};

Sith::Profiler::~Profiler()
{
	std::ostringstream Stream;

	int len = ProfilerName.length();

	Stream << ProfilerName << " ";
	for(int i = 0; i < (48 - len); ++i)
	{
		Stream << "-";
	};

	double Percentage = ((TimerAccumulator / TotalAccumulator) * 100);

	char String[96];
	memset(String, 0, sizeof(char) * 96);
	_snprintf(String, 95, "%3.5f", Percentage);

	// goddamn snprintf doesn't work worth a damn >:(

	if(Percentage < 100.0)
	{
		Stream << " ";
	};

	if(Percentage < 10.0)
	{
		Stream << " ";
	};

	Stream << " " << String << "%" << std::endl;

	FILE* LogFile = fopen(Sith::COG::CogLib::GetSetting("log::profile").GetString().c_str(), "at");
	if(LogFile)
	{
		fwrite(Stream.str().c_str(), sizeof(char), Stream.str().length(), LogFile);
		fclose(LogFile);
	};

	return;
};
