/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _RES_H_INCLUDED_
#define _RES_H_INCLUDED_

namespace Sith
{
	namespace VFS
	{
		class Resource
		{
		private:
			std::string SystemName; // Name of the resource in the system (this would be the filename, typically, in Sith 2. In Project Raven this would be a universal short name)
			unsigned long ReferenceCount;	// Number of references made to this resource. Used for automatic garbage collection.

		protected:
			// You have to derive from this class
			Resource(std::string Name) : SystemName(Name)
			{
				return;
			};

			~Resource()
			{
				return;
			};

		public:
			inline void AddRef()
			{
				++ReferenceCount;
				return;
			};

			inline unsigned long GetRefCt()
			{
				return ReferenceCount;
			};

			inline void Release()
			{
				--ReferenceCount;
				return;
			};

			inline std::string& GetName()
			{
				return SystemName;
			};
		};
	};
};

#endif // _RES_H_INCLUDED_