/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

Sith::Res::Font::Font (std::string FileName) : Sith::VFS::Resource(FileName) {
	Offset = 0;
	memset (AllCharDefs, 0, sizeof(CharDef*) * 256);
	return;
}

Sith::SITHERROR Sith::Res::Font::LoadFromFile (const char* FileBuffer) {
	memcpy (&FontHeader, FileBuffer + Offset, sizeof(FontHeader));
	Offset += sizeof(FontHeader);
	if (!(FontHeader.FileType[0] == 'S' && FontHeader.FileType[1] == 'F' && FontHeader.FileType[2] == 'N' && FontHeader.FileType[3] == 'T')) {
		ConOut ("ERROR: Invalid SFT file type in header.\n", ConOut::Error);
		return SE_FILE_CORRUPT;
	}

	CharacterTables.resize (FontHeader.NumTables);

	std::vector<CharacterTable>::iterator it;
	for (it = CharacterTables.begin(); it != CharacterTables.end(); it++) {
		unsigned int i;
		memcpy (&(*it), FileBuffer + Offset, sizeof(short int) * 2);
		Offset += sizeof(short int) * 2;
		it->CharDefs.resize (it->LastChar - it->FirstChar + 1);
		memcpy (&(it->CharDefs[0]), FileBuffer + Offset, it->CharDefs.size() * sizeof(CharDef));
		Offset += it->CharDefs.size() * sizeof(CharDef);
		for (i = 0; i < (it->LastChar - it->FirstChar + 1); i++) {
			AllCharDefs[it->FirstChar + i] = &(it->CharDefs[i]);
		}
	}

	// parse the BM data
	FontBitmap = new Res::Bitmap ("none");
	FontBitmap->LoadFromFile (FileBuffer + Offset);

	return SE_OK;
}

Sith::Res::Font::~Font () {
	return;
}