/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _SFTFILE_H_INCLUDED_
#define _SFTFILE_H_INCLUDED_

namespace Sith {
	namespace Res {
		class Font : public VFS::Resource {
		public:
			unsigned int Offset;

			struct Header {
				char			FileType[4];	// "SFNT"
				int				Unknown1;		// 0x0A
				int				Unknown2, Unknown3, Unknown4;
				unsigned int	NumTables;		// Number of character tables
				int				Padding[4];
			};

			struct CharDef {
				unsigned int	Offset;			// X offset of char in image data
				unsigned int	Width;			// Width of image in pixels
			};

			struct CharacterTable {
				short int				FirstChar;
				short int				LastChar;
				std::vector<CharDef>	CharDefs;
			};

			Header							FontHeader;
			std::vector<CharacterTable>		CharacterTables;
			CharDef							*AllCharDefs[256];
			VFS::WisePointer<Res::Bitmap>	FontBitmap;

			Font (std::string FileName);
			SITHERROR LoadFromFile (const char* FileBuffer);
			~Font ();
		};
	};
};



#endif