/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _THING_H_INCLUDED_
#define _THING_H_INCLUDED_

namespace Sith
{
	namespace Gameplay
	{
		class Thing : public Template
		{
		public:
			std::string Name;

			Math::Vector Pos;
			float HeadPitch;

			int Sector;

			int ThingFlags;

			int ActorFlags;

			int COGLinked;

			bool Instanced; // false if not spawned/taken

			Sith::Math::Vector Thrust;

			struct FRAME {
				float X, Y, Z, Pitch, Yaw, Roll;
				bool AffectOrient;
			};

			int CurFrame;			// frame the thing is either staying at or leaving from
			int DestFrame;			// frame the thing is seeking
			float FrameSpeed;		// this is not in JKU's/sec, we're assuming it's in 10 JKUs/sec
			std::vector<FRAME> Frames;	

			std::string AIClass;

			COG::StackMachine* ClassScript;
			COG::StackMachine* FilterScript; // unused for now
			
			float Health;

			int Parent;				// unused for now

			enum ATTACHSTATE
			{
				FREE,
				SURFACE,
				THING
			} AttachState;

			int AttachIndex;

			enum THINGTYPE {
				TT_FREE,
				TT_CAMERA,
				TT_ACTOR,
				TT_WEAPON,
				TT_DEBRIS,
				TT_ITEM,
				TT_EXPLOSION,
				TT_COG,
				TT_GHOST,
				TT_CORPSE,
				TT_PLAYER,
				TT_PARTICLE
			} ThingType;

			std::vector<COG::StackMachine*> LinkTable;

			int operator=(const Template& Parent);
		};
	};
};

#endif // _THING_H_INCLUDED_