/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _UICOLORS_H_INCLUDED_
#define _UICOLORS_H_INCLUDED_

namespace Sith
{
	namespace UI
	{
		enum UIColorState
		{
			UICS_FLAT,
			UICS_TDGRADIENT,
			UICS_LRGRADIENT,
		};

		enum UIBitmapState
		{
			UIBS_NONE,
			UIBS_NORMAL,
			UIBS_FIT,
		};

		enum UIRectState
		{
			UIRS_NORMAL=0,
			UIRS_TOPLEFT=0,
			UIRS_TOPRIGHT,
			UIRS_BOTTOMLEFT,
			UIRS_BOTTOMRIGHT,
		};

		union UIColor
		{
			unsigned __int32 RawColor;
			struct
			{
				unsigned char R;
				unsigned char G;
				unsigned char B;
				unsigned char A;
			} Elements;

			UIColor(unsigned char R, unsigned char G, unsigned char B, unsigned char A=0xFF)
			{
				Elements.R = R;
				Elements.G = G;
				Elements.B = B;
				Elements.A = A;
				return;
			};

			UIColor()
			{
				Elements.R = 0x00;
				Elements.G = 0x00;
				Elements.B = 0x00;
				Elements.A = 0x00;
				return;
			};
		};

		namespace StandardColors
		{
			const UIColor Black(0x0, 0x0, 0x0, 0xFF);
			const UIColor White(0xFF, 0xFF, 0xFF, 0xFF);
			const UIColor Red(0xFF, 0x0, 0x0, 0xFF);
			const UIColor Blue(0x0, 0x0, 0xFF, 0xFF);
			const UIColor Green(0x0, 0xFF, 0x0, 0xFF);

			const UIColor LightGrey(0xC0, 0xC0, 0xC0, 0xFF);
			const UIColor DarkGrey(0x80, 0x80, 0x80, 0xFF);

			const UIColor Brown(0x80, 0x40, 0x00, 0xFF);
		};
	};
};

#endif // _UICOLORS_H_INCLUDED_