/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"
#include "uihud.h"

#include "gamestate.h"

Sith::UI::HUD::HUD() : Task("Heads-Up Display")
{
	TransparencyCache = 0;
	HudSizeCache = 0.0f;

	HPImageCt = 0;
	ShldImageCt = 0;
	BatImageCt = 0;
	return;
};

Sith::UI::HUD::~HUD()
{
	return;
};

Sith::SITHERROR Sith::UI::HUD::Startup()
{
	HUDBase = &Sith::UI::UIMain::Get().GetRootWindow().CreateChild();
	HUDBase->SetColorState(UICS_FLAT);
	HUDBase->SetColor(UIColor(0, 0, 0, 0), 1);
	HUDBase->SetColor(UIColor(0, 0, 0, 0), 2);
	HUDBase->SetRectState(UIRS_NORMAL);

	// Create widgets:
    
	// Create left:
	Left = &HUDBase->CreateChild();
	Left->SetRectState(UIRS_BOTTOMLEFT);
	Left->SetBitmap("statusleft16.bm");
	Left->SetBitmapState(UIBS_FIT);
	Left->SetPosition(0, 0);
	Left->SetSize(120, 120);
	Left->SetColorState(UICS_FLAT);
	Left->SetColor(StandardColors::White);

	Health = &HUDBase->CreateChild();
	Health->SetRectState(UIRS_BOTTOMLEFT);
	Health->SetBitmap("sthealth16.bm");
	Health->SetBitmapState(UIBS_FIT);
	Health->SetPosition(40, 40);
	Health->SetSize(40, 40);
	Health->SetColorState(UICS_FLAT);
	Health->SetColor(StandardColors::White);
	Health->SetBitmapNumber(0);

	VFS::WisePointer<Res::Bitmap> hpbm = VFS::ResourceManager::Get().GetBitmap("sthealth16.bm");
	if(hpbm.isValid())
	{
		HPImageCt = hpbm->Images.size();
	}
	else
	{
		HPImageCt = 1;
	};

	Shield = &HUDBase->CreateChild();
	Shield->SetRectState(UIRS_BOTTOMLEFT);
	Shield->SetBitmap("stshield16.bm");
	Shield->SetBitmapState(UIBS_FIT);
	Shield->SetPosition(20, 20);
	Shield->SetSize(80, 80);
	Shield->SetColorState(UICS_FLAT);
	Shield->SetColor(StandardColors::White);
	Shield->SetBitmapNumber(0);

	VFS::WisePointer<Res::Bitmap> slbm = VFS::ResourceManager::Get().GetBitmap("stshield16.bm");
	if(slbm.isValid())
	{
		ShldImageCt = slbm->Images.size();
	}
	else
	{
		ShldImageCt = 1;
	};

	HealthCtr = &HUDBase->CreateChild();
	HealthCtr->SetRectState(UIRS_BOTTOMLEFT);
	HealthCtr->SetBitmapState(UIBS_NONE);
	HealthCtr->SetColorState(UICS_FLAT);
	HealthCtr->SetColor(StandardColors::Black);
	HealthCtr->SetPosition(27, 35);
	HealthCtr->SetSize(32, 16);
	HealthCtr->SetText("123");
	HealthCtr->SetFontScale(2.0f);
	HealthCtr->SetFont("helthnum16.sft");

	ShieldCtr = &HUDBase->CreateChild();
	ShieldCtr->SetRectState(UIRS_BOTTOMLEFT);
	ShieldCtr->SetBitmapState(UIBS_NONE);
	ShieldCtr->SetColorState(UICS_FLAT);
	ShieldCtr->SetColor(StandardColors::Black);
	ShieldCtr->SetPosition(0, 0);
	ShieldCtr->SetSize(32, 16);
	ShieldCtr->SetText("123");
	ShieldCtr->SetFontScale(2.0f);
	ShieldCtr->SetFont("armornum16.sft");

	// Create right:
	Right = &HUDBase->CreateChild();
	Right->SetRectState(UIRS_BOTTOMRIGHT);
	Right->SetBitmap("statusright16.bm");
	Right->SetBitmapState(UIBS_FIT);
	Right->SetPosition(0, 0);
	Right->SetSize(120, 120);
	Right->SetColorState(UICS_FLAT);
	Right->SetColor(StandardColors::White);

	FieldLight = &HUDBase->CreateChild();
	FieldLight->SetRectState(UIRS_BOTTOMRIGHT);
	FieldLight->SetBitmap("stfieldlite16.bm");
	FieldLight->SetBitmapState(UIBS_FIT);
	FieldLight->SetPosition(0, 0);
	FieldLight->SetSize(120, 120);
	FieldLight->SetColorState(UICS_FLAT);
	FieldLight->SetColor(StandardColors::White);

	Batteries = &HUDBase->CreateChild();
	Batteries->SetRectState(UIRS_BOTTOMRIGHT);
	Batteries->SetBitmap("stbat16.bm");
	Batteries->SetBitmapState(UIBS_FIT);
	Batteries->SetPosition(0, 0);
	Batteries->SetSize(120, 120);
	Batteries->SetColorState(UICS_FLAT);
	Batteries->SetColor(StandardColors::White);

	AmmoCtr = &HUDBase->CreateChild();
	AmmoCtr->SetRectState(UIRS_BOTTOMRIGHT);
	AmmoCtr->SetBitmapState(UIBS_NONE);
	AmmoCtr->SetColorState(UICS_FLAT);
	AmmoCtr->SetColor(StandardColors::Black);
	AmmoCtr->SetPosition(0, 0);
	AmmoCtr->SetSize(32, 16);
	AmmoCtr->SetText("100");
	AmmoCtr->SetFontScale(2.0f);
	AmmoCtr->SetFont("amonums16.sft");

	VFS::WisePointer<Res::Bitmap> batbm = VFS::ResourceManager::Get().GetBitmap("stbat16.bm");
	if(batbm.isValid())
	{
		BatImageCt = batbm->Images.size();
	}
	else
	{
		BatImageCt = 1;
	};

	Mana = &HUDBase->CreateChild();
	Mana->SetRectState(UIRS_BOTTOMRIGHT);
	Mana->SetBitmap("stfrc16.bm");
	Mana->SetBitmapState(UIBS_FIT);
	Mana->SetPosition(0, 0);
	Mana->SetSize(120, 120);
	Mana->SetColorState(UICS_FLAT);
	Mana->SetColor(StandardColors::White);

	VFS::WisePointer<Res::Bitmap> manbm = VFS::ResourceManager::Get().GetBitmap("stfrc16.bm");
	if(manbm.isValid())
	{
		ManaImageCt = manbm->Images.size();
	}
	else
	{
		ManaImageCt = 1;
	};

	return SE_OK;
};

Sith::SITHERROR Sith::UI::HUD::Process()
{
	if(!Sith::Gameplay::WorldState::Get().CurrentLevel.isValid())
	{
		HUDBase->Hide();
		return SE_OK;
	}
	else HUDBase->Show();

	float NewSize = Sith::COG::CogLib::GetSetting("ui::hudsize").GetFloat();

	HUDBase->SetRect(UIMain::Get().GetRootWindow().GetRect());

	if(Sith::COG::CogLib::GetSetting("ui::drawhud").GetBool())
	{
		HUDBase->Show();
	}
	else
	{
		HUDBase->Hide();
	};

	if(NewSize != HudSizeCache)
	{
		HudSizeCache = NewSize;

		Left->SetSize(60 * NewSize, 60 * NewSize);

		Health->SetPosition(20 * NewSize, 20 * NewSize);
		Health->SetSize(20 * NewSize, 20 * NewSize);

		Shield->SetPosition(10 * NewSize, 10 * NewSize);
		Shield->SetSize(40 * NewSize, 40 * NewSize);

		HealthCtr->SetPosition(13 * NewSize, 17 * NewSize);
		HealthCtr->SetSize(15 * NewSize, 8 * NewSize);
		HealthCtr->SetFontScale(NewSize);

		ShieldCtr->SetPosition(23 * NewSize, 9 * NewSize);
		ShieldCtr->SetSize(15 * NewSize, 8 * NewSize);
		ShieldCtr->SetFontScale(NewSize);

		Right->SetSize(60 * NewSize, 60 * NewSize);

		FieldLight->SetPosition(51 * NewSize, 41 * NewSize);
		FieldLight->SetSize(10 * NewSize, 10 * NewSize);

		Batteries->SetPosition(24 * NewSize, 45 * NewSize);
		Batteries->SetSize(27 * NewSize, 15 * NewSize);

		Mana->SetPosition(10 * NewSize, 7 * NewSize);
		Mana->SetSize(40 * NewSize, 20 * NewSize);

		AmmoCtr->SetPosition(13 * NewSize, 28 * NewSize);
		AmmoCtr->SetSize(34 * NewSize, 13 * NewSize);
		AmmoCtr->SetFontScale(NewSize);
	};

	int PlayerThing = Gameplay::WorldState::Get().LocalPlayerThing;
	if((PlayerThing >= 0) && (PlayerThing < Gameplay::WorldState::Get().ThingList.size()))
	{
		Gameplay::Thing* lpt = &Gameplay::WorldState::Get().ThingList[PlayerThing];
		char CtrTxt[4];
		CtrTxt[3] = '\0';

		int ctn = lpt->Health;

		unsigned int ImgNum = 0;

		if(ctn < 0)
		{
			HealthCtr->SetText("000");
		}
		else if(ctn < 10)
		{
			CtrTxt[0] = '0';
			CtrTxt[1] = '0';
			_snprintf(&CtrTxt[2], 1, "%d", ctn);
			HealthCtr->SetText(std::string(CtrTxt));
		}
		else if(ctn < 100)
		{
			CtrTxt[0] = '0';
			_snprintf(&CtrTxt[1], 2, "%d", ctn);
			HealthCtr->SetText(std::string(CtrTxt));
		}
		else
		{
			_snprintf(CtrTxt, 3, "%d", ctn);
			HealthCtr->SetText(std::string(CtrTxt));
		};

		ImgNum = ((lpt->MaxHealth - ctn) / (lpt->MaxHealth)) * ((float)HPImageCt - 1);

		Health->SetBitmapNumber(ImgNum);

		float MaxShld = 0;

		if(Gameplay::GameState::Get().BinList.size() > 60)
		{
			ctn = Gameplay::GameState::Get().BinList[60].Value;
			MaxShld = Gameplay::GameState::Get().BinList[60].Max;
		}
		else
		{
			ctn = 0;
		};

		if(ctn < 0)
		{
			ShieldCtr->SetText("000");
		}
		else if(ctn < 10)
		{
			CtrTxt[0] = '0';
			CtrTxt[1] = '0';
			_snprintf(&CtrTxt[2], 1, "%d", ctn);
			ShieldCtr->SetText(std::string(CtrTxt));
		}
		else if(ctn < 100)
		{
			CtrTxt[0] = '0';
			_snprintf(&CtrTxt[1], 2, "%d", ctn);
			ShieldCtr->SetText(std::string(CtrTxt));
		}
		else
		{
			_snprintf(CtrTxt, 3, "%d", ctn);
			ShieldCtr->SetText(std::string(CtrTxt));
		};

		ImgNum = ((MaxShld - ctn) / (MaxShld)) * ((float)ShldImageCt - 1);

		Shield->SetBitmapNumber(ImgNum);

		float MaxBat = 0;

		if(Gameplay::GameState::Get().BinList.size() > 13)
		{
			ctn = Gameplay::GameState::Get().BinList[13].Value;
			MaxBat = Gameplay::GameState::Get().BinList[13].Max;
		}
		else
		{
			ctn = 0;
		};

		ImgNum = (ctn / MaxBat) * ((float)BatImageCt - 1);

		Batteries->SetBitmapNumber(ImgNum);

		float MaxMan = 0;

		if(Gameplay::GameState::Get().BinList.size() > 14)
		{
			ctn = Gameplay::GameState::Get().BinList[14].Value;
			MaxMan = Gameplay::GameState::Get().BinList[14].Max;
		}
		else
		{
			ctn = 0;
		};

		ImgNum = ((MaxMan - ctn) / (MaxMan)) * ((float)ManaImageCt - 1);

		Mana->SetBitmapNumber(ImgNum);

		bool LightOn = false;

		if(Gameplay::GameState::Get().BinList.size() > 42)
		{
			LightOn = Gameplay::GameState::Get().BinList[42].Activated;
		}
		else
		{
			LightOn = false;
		};

		if(LightOn)
		{
			FieldLight->SetBitmapNumber(1);
		}
		else
		{
			FieldLight->SetBitmapNumber(0);
		};

		AmmoCtr->SetText("018");
	};

	return SE_OK;
};
