/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"

#include "uiwidget.h"
#include "uimain.h"

#include "uiwin.h"

Sith::UI::UIMain* Sith::UI::UIMain::StaticInterface = 0;

Sith::UI::UIMain::UIMain() : Task("User Interface")
{
	if(StaticInterface)
	{
		ConOut("WARNING: Attempted to create multiple instances of the User Interface module for a single instance of the engine.\n", ConOut::Warning);
	};

	StaticInterface = this;

	RootWidget.SetColorState(UICS_FLAT);
	RootWidget.SetColor(UIColor(0, 0, 0, 0), 1);
	RootWidget.SetColor(UIColor(0, 0, 0, 0), 2);

	// Add HUD configuration options:
	COG::CogLib::InjectNamespace("ui");
	COG::CogLib::AddSetting("ui::hudsize", COG::VMType((float)1.0f));
	COG::CogLib::AddSetting("ui::transparency", COG::VMType((int)255));
	COG::CogLib::AddSetting("ui::drawhud", COG::VMType((bool)true));
	COG::CogLib::AddSetting("ui::drawfps", COG::VMType((bool)false));

	return;
};

Sith::UI::UIMain::~UIMain()
{
	return;
};

Sith::SITHERROR Sith::UI::UIMain::Startup()
{
	BaseWidget& BetaTxt = RootWidget.CreateChild();

	BetaTxt.SetColor(UIColor(0, 0, 0, 0), 1);
	BetaTxt.SetColor(UIColor(0, 0, 0, 0), 2);
	BetaTxt.SetColorState(UICS_FLAT);

	BetaTxt.SetFont("small1.sft");
	BetaTxt.SetFontScale(2.0f);

	BetaTxt.SetText("CLOSED PRE-ALPHA");
	BetaTxt.SetRectState(UIRS_TOPLEFT);
	BetaTxt.SetRect(UIRect(10, 10, 300, 100));

	BaseWidget& NDATxt = RootWidget.CreateChild();

	NDATxt.SetColor(UIColor(0, 0, 0, 0), 1);
	NDATxt.SetColor(UIColor(0, 0, 0, 0), 2);
	NDATxt.SetColorState(UICS_FLAT);

	NDATxt.SetFont("small1.sft");
	NDATxt.SetFontScale(2.0f);

	NDATxt.SetText("DO NOT DISTRIBUTE");
	NDATxt.SetRectState(UIRS_BOTTOMLEFT);
	NDATxt.SetRect(UIRect(10, 150, 300, 100));

	return SE_OK;
};

Sith::SITHERROR Sith::UI::UIMain::Process()
{
	return SE_OK;
};