/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _UNI_H_INCLUDED_
#define _UNI_H_INCLUDED_

namespace Sith
{
	namespace COG
	{
		class UniTable
		{
		private:
			std::map<std::string, std::string> UniT;

		public:
			SITHERROR Load(std::string PathName);
			
			inline SITHERROR Add(std::string Key, std::string Data)
			{
				std::transform(Key.begin(), Key.end(), Key.begin(), toupper);
				UniT[Key] = Data;
				return SE_OK;
			};

			inline std::string Get(std::string Key)
			{
				std::transform(Key.begin(), Key.end(), Key.begin(), toupper);
				return UniT[Key];
			};

			inline void Clear()
			{
				UniT.clear();
				return;
			};
		};
	};
};

#endif // _UNI_H_INCLUDED_