/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

%{
#include "stdafx.h"

#include "uni.h"

#include "uni.y.hpp"

int UNIerror(char *s);
int UNIlex(void);

extern char *yytext;

extern int UNIlineno;

extern Sith::COG::UniTable* GlobalUni;

%}

%union { int Integer; char *String; }

%token <String> UNI_LITERAL_STRING
%token <Integer> UNI_INTEGER

%token UNI_MSGS UNI_END

%type <String> string_literal

%start unifile

%%

string_literal
	: UNI_LITERAL_STRING
		{
			std::string StrTmp = std::string($1);
			std::string StrBuf;
			// Translate and output STRING LITERALS:
			int i = 1;
			while(StrTmp[i] != '\"' && StrTmp[i] != '\0')
			{
				if(StrTmp[i] == '\\')
				{
					++i;
					if(StrTmp[i] == 'n')
					{
						StrBuf.push_back('\n');
					}
					else if(StrTmp[i] == '\"')
					{
						StrBuf.push_back('\"');
					}
					else if(StrTmp[i] == 't')
					{
						StrBuf.push_back('\t');
					}
					else if(StrTmp[i] == '\0')
					{
						break;
					}
					
					++i;
					continue;
				}
				else
				{
					StrBuf.push_back(StrTmp[i++]);
					continue;
				};
			};
			$$ = strdup(StrBuf.c_str());
			free($1);
		}
	;

uni_item
	: string_literal UNI_INTEGER string_literal
		{
			GlobalUni->Add($1, $3);
			free($1);
			free($3);
		}
	;

uni_list
	: uni_item
	| uni_list uni_item
	;

unifile
	: UNI_MSGS UNI_INTEGER uni_list UNI_END
	;
	
%%

int UNIerror(char* s)
{
	extern int UNIlineno;
	extern char *UNItext;
	
	std::stringstream ErrorString;
	ErrorString << "ERROR: \"" << std::string(s) << "\" at symbol \"" << std::string(UNItext) << "\" on line " << UNIlineno << "\n";
	ConOut(ErrorString.str(), ConOut::Error);
	
	return 1;
};