/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _VDIRECTORY_H_INCLUDED_
#define _VDIRECTORY_H_INCLUDED_

namespace Sith
{
	namespace VFS
	{
		class VDirectory
		{
		private:
			std::list<VDirectory> SubDirectories;
			std::list<VFile> SubFiles;

		public:
			std::string Name;

			VDirectory* GetDirectory(std::string theName);
			VDirectory* MakeDirectory(std::string theName);
			VFile* GetFile(std::string theName);
			VFile* MakeFile(std::string theName, std::string theContainerFile, unsigned int theOffset, unsigned int theLength);

			VDirectory(std::string theName);

			int ls(std::string PrevName);
		};
	};
};

#endif // _VDIRECTORY_H_INCLUDED_