/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _W32_TIMER_H_INCLUDED_
#define _W32_TIMER_H_INCLUDED_

namespace Sith
{
	namespace Win32
	{
		class Timer
		{
		private:
			LARGE_INTEGER PrevSample;
			LARGE_INTEGER CurrentSample;
			LARGE_INTEGER Frequency;

		public:
			Timer()
			{
				QueryPerformanceFrequency(&Frequency);
				QueryPerformanceCounter(&CurrentSample);
			};

			// Query returns the amount of time that's passed since the last time the timer was queried.
			inline double Query()
			{
				PrevSample = CurrentSample;
				QueryPerformanceCounter(&CurrentSample);
				return ((double)CurrentSample.QuadPart - (double)PrevSample.QuadPart) / (double)Frequency.QuadPart;
			};
		};
	};
};

#endif // _W32_TIMER_H_INCLUDED_